 
/* 
 *      (c) Copyright 1991 Sun Microsystems, Inc. Sun design patents 
 *      pending in the U.S. and foreign countries. See LEGAL NOTICE 
 *      file for terms of the license.
 */

/*
  defs for fifo routines
  */

typedef struct q_entry {
  struct q_entry * next;
  thread_id_t thread_id;
  condvar_t cv;
  int ok_to_run;
} q_entry_t;

typedef struct fifo {
  q_entry_t * head, * tail;
  mutex_t mutex;
  thread_id_t holder;
  int waiting, recursion;
} fifo_t;

void 	fifo_init(fifo_t * fifo, int type, void * arg);
int 	fifo_enter(fifo_t * fifo, void (*func)(), void * arg);
void 	fifo_yield(fifo_t * fifo, unsigned int count);
int  	fifo_tryenter(fifo_t * fifo);
void 	fifo_exit(fifo_t * fifo);
int 	fifo_num_waiters(fifo_t * fifo);
